//
// MemStructs.cs
//
// Author:
//       Carsten Sonne Larsen <cs@innolan.net>
//
// Copyright (c) 2014 Carsten Sonne Larsen
//
// Permission is hereby granted, free of charge, to any person obtaining a copy
// of this software and associated documentation files (the "Software"), to deal
// in the Software without restriction, including without limitation the rights
// to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
// copies of the Software, and to permit persons to whom the Software is
// furnished to do so, subject to the following conditions:
//
// The above copyright notice and this permission notice shall be included in
// all copies or substantial portions of the Software.
//
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
// IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
// FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
// AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
// LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
// OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
// THE SOFTWARE.

namespace Ntp.Monitor
{
    /*
    [StructLayout(LayoutKind.Explicit)]
    public struct struct1
    {
        [FieldOffset(0)]
            public byte a;   // 1 byte
        [FieldOffset(1)]
            public int b;    // 4 bytes
        [FieldOffset(5)]
            public short c;  // 2 bytes
        [FieldOffset(7)]
            public byte buffer;
        [FieldOffset(18)]
            public byte d;   // 1 byte
    }


    [StructLayout(LayoutKind.Sequential, Pack = 1)]
    public  struct DISPLAY_DEVICE
    {
        public int cb;
        public fixed char DeviceName[32];
        public fixed char DeviceString[128];
        public int StateFlags;
        public fixed char DeviceID[128];
        public fixed char DeviceKey[128];
    }

    The third and final method is to use custom marshalling. Many C# programmers don’t realise that marshalling
    isn’t just about the way that the system types data for passing to DLLs – instead it is an active process
    that copies and transforms the managed data. For example, if you choose to pass a reference to an array of
    typed elements then you can ask for it to be marshalled as a value array and the system will convert it into
    a fixed length buffer, and back to a managed array, without any extra effort on your part.

    In this case all we have to do is add the MarshalAs attribute, specify the type and size of the arrays:

    [StructLayout(LayoutKind.Sequential,
    Pack = 1, CharSet = CharSet.Unicode)]
    public struct DISPLAY_DEVICE
    {
        public int cb;
        [MarshalAs(
            UnmanagedType.ByValArray,
            SizeConst=32)]
            public char[] DeviceName;
        [MarshalAs(
            UnmanagedType.ByValArray,
            SizeConst=128)]
            public char[] DeviceString;
        public int StateFlags;
        [MarshalAs(
            UnmanagedType.ByValArray,
            SizeConst = 128)]
            public char[] DeviceID;
        [MarshalAs(
            UnmanagedType.ByValArray,
            SizeConst = 128)]
            public char[] DeviceKey;
    }

    */
}